searchNodes=[{"doc":"Provides helpers for destructuring Elixir data structures. See the d/1 macro for more information.","ref":"Destructure.html","title":"Destructure","type":"module"},{"doc":"Easy destructuring of map, structs, keyword, with atom keys. String keys are supported via a special syntax d(s%{param}).ExamplesThe macro can be used in simple match statements:iex&gt; d(%{name}) = %{name: &quot;Joe&quot;} ...&gt; name &quot;Joe&quot;Or in case/for/with statements.iex&gt; case %{name: &quot;Mike&quot;} do ...&gt; d%{name} -&gt; name ...&gt; end &quot;Mike&quot;It can be used inside a complex match:iex&gt; %{body: d%{name}} = %{body: %{name: &quot;Robert&quot;}} ...&gt; name &quot;Robert&quot;With multiple keys:iex&gt; d(%{first, last}) = %{first: &quot;Daniel&quot;, last: &quot;Berkompas&quot;} ...&gt; {first, last} {&quot;Daniel&quot;, &quot;Berkompas&quot;}With multiple keys and custom variable naming:iex&gt; d(%{first, last, email: mail}) = %{first: &quot;Daniel&quot;, last: &quot;Berkompas&quot;, email: &quot;top@secret.com&quot;} ...&gt; {first, last, mail} {&quot;Daniel&quot;, &quot;Berkompas&quot;, &quot;top@secret.com&quot;}For Maps with String Keys:iex&gt; s(%{name}) = %{&quot;name&quot; =&gt; &quot;Daniel Berkompas&quot;} ...&gt; name &quot;Daniel Berkompas&quot;With multiple keys:iex&gt; s(%{name, email}) = %{&quot;name&quot; =&gt; &quot;Daniel Berkompas&quot;, &quot;email&quot; =&gt; &quot;top@secret.com&quot;} ...&gt; {name, email} {&quot;Daniel Berkompas&quot;, &quot;top@secret.com&quot;}With multiple keys and custom variable naming:iex&gt; s(%{name, &quot;email&quot; =&gt; mail}) = %{&quot;name&quot; =&gt; &quot;Daniel Berkompas&quot;, &quot;email&quot; =&gt; &quot;top@secret.com&quot;} ...&gt; {name, mail} {&quot;Daniel Berkompas&quot;, &quot;top@secret.com&quot;}For structs:iex&gt; d(%Person{name}) = %Person{name: &quot;Daniel Berkompas&quot;} ...&gt; name &quot;Daniel Berkompas&quot;With multiple keys:iex&gt; d(%Person{name, email}) = %Person{name: &quot;Daniel Berkompas&quot;, email: &quot;top@secret.com&quot;} ...&gt; {name, email} {&quot;Daniel Berkompas&quot;, &quot;top@secret.com&quot;}With multiple keys and custom variable naming:iex&gt; d(%Person{name, email: mail}) = %Person{name: &quot;Daniel Berkompas&quot;, email: &quot;top@secret.com&quot;} ...&gt; {name, mail} {&quot;Daniel Berkompas&quot;, &quot;top@secret.com&quot;}For keyword lists:iex&gt; d([name]) = [name: &quot;Daniel&quot;] ...&gt; name &quot;Daniel&quot;With multiple keys:iex&gt; d([first, last]) = [first: &quot;Daniel&quot;, last: &quot;Berkompas&quot;] ...&gt; [first, last] [&quot;Daniel&quot;, &quot;Berkompas&quot;]With multiple keys and custom assignment:iex&gt; d([first, last, email: mail]) = [first: &quot;Daniel&quot;, last: &quot;Berkompas&quot;, email: &quot;top@secret.com&quot;] ...&gt; [first, last, mail] [&quot;Daniel&quot;, &quot;Berkompas&quot;, &quot;top@secret.com&quot;]And in function definitions:iex&gt; defmodule Test do ...&gt; import Destructure ...&gt; def test(d%{name}) do ...&gt; name ...&gt; end ...&gt; end ...&gt; Test.test(%{name: &quot;Daniel&quot;}) &quot;Daniel&quot;","ref":"Destructure.html#d/1","title":"Destructure.d/1","type":"macro"},{"doc":"","ref":"Destructure.html#s/1","title":"Destructure.s/1","type":"macro"}]